<?php

$spxsNS = 'http://www.spinetix.com/namespace/1.0/spxstatus';
$spxsP = 'spxs';

require_once "/usr/share/resources/default/interface/branding.php"; // branding info

// Serial number
function getInfoSerial( &$serial, &$model, &$hardware ) {
	$serial="[undefined]";
	$cpuinfo=file_get_contents("/proc/cpuinfo");
	if (preg_match("/Serial\s+:\s+(\S+)/",$cpuinfo,$match))
		$serial=$match[1];
	
	$model = "Bonsai";
	if (preg_match("/Hardware\W+:\s+(\w+)/",$cpuinfo,$match)){
		$model = $match[1];
	}
	$hardware = "x.x/x.x";
	if (preg_match("/Revision\W+:\s+(\w+)/",$cpuinfo,$match)){
		if ( $model=='Bonsai') {
			$val=hexdec($match[1]);
			$valc= floor($val/65536);
			$core = floor($valc/256).".".($valc % 256);
			$valc= $val % 65536;
			$carier = floor($valc/256).".".($valc % 256);
			$hardware= $core."/".$carier ;
		} else {
			$val=hexdec($match[1]);
			$valc= $val % 65536;
			$carier = floor($valc/256).".".($valc % 256);
			$hardware= $carier ;
		}
	}
}
function getInfoModel() {
	global $product;
	return $product;
}

function getInfoSafeMode() {
	return file_exists("/var/run/raperca.safe");
}

function getInfoUpTime() {
	$uptime=file_get_contents("/proc/uptime");
	$uptime=explode(" ",$uptime);
	return $uptime[0];
}

	
function getInfoIp( &$ip, &$ipprefix, &$iptype) {
	$ipcmd=shell_exec('ip -o -f inet addr show');
	preg_match_all("@^\d+:\s*(\S+)\s+.*\binet\s+([\d.]+)(?:/(\d+)|\s+)@m", $ipcmd, $matches, PREG_SET_ORDER);

	# Multidimensional array. Each IP
    # address gets a row, and each row has three entries: the IP
    # address, prefix length, interface type (e.g., 'ethernet',
    # 'modem') and the interface name (e.g., 'eth0', 'ppp0'). The "main"
    # address is returned in the first row. The loopback interface
    # is not returned.
	$addrs = array();
	foreach ($matches as $idx => $value) {
		$iface = $value[1];
		$addr = $value[2];
		$plen = $value[3];

		if ( ! $plen )
			$plen = 32;

		$order = 0; // to order the addresses by decreasing importance

		// add n in [0-99] to ordering to keep ordering if all other
		// ordering criteria are equal
		$order += $idx;

		if ( strncmp($iface, 'eth', 3) == 0 )
			$type = 'ethernet';
		elseif ( strncmp($iface, 'ppp', 3) == 0 )
			$type = 'modem';
		elseif ( $iface == 'lo' )
			$type = 'loopback';
		if ( $iface == 'lo' )
			continue;

		// add n*100 to order for interface type (n in [0,9])
		if ( $type == 'modem' )
			$order += 100;
		elseif ( $type == 'ethernet' )
			$order += 800;
		else
			$order += 900;

		// add n*1000 to order for address class (n in [0,9])
		if (strncmp($addr, '169.254', 7) == 0 )
			$order += 8000; // link-local
		if (strncmp($addr, '127.', 4) == 0 )
			$order += 9000; // host-local

		$addrs[$order] = array($addr, $plen, $type, $iface);
	}

	// apply the ordering
	ksort($addrs);
	$addr = reset($addrs);
	if ($addr) {
		$ip=$addr[0];
		$ipprefix=$addr[1];
		$iptype=ucfirst($addr[2]);
	} else {
		$ip = "[not found]";
		$ipprefix = "";
		$iptype= "Unknown";
	}
	return $addrs;
}
function getInfoMac () {
	if ( $_ENV['OS']=='Windows_NT' ) {
		return "00:1D:50:00:00:XX";
	} else {
		$info=`ifconfig eth0`;
		$macp=strpos($info,"HWaddr ");
		if ($macp===false) 
			return "[not found]";
		$macp=$macp+strlen("HWaddr ");
		return substr($info, $macp, strpos($info," ",$macp)-$macp);
	}            
}
function getInfoHostname() {
	return trim(file_get_contents("/etc/hostname"));
}  

function getInfoFirmware( &$firmware, &$build ) {
	$release = file_get_contents('/etc/spinetix-release');
	$vals=explode(" ", $release);
	if (count($vals)==6 ){
		$firmware = $vals[3];
		$build = $vals[5];
	} else {
		$firmware = "[not found]";
		$build = "";
	}
}

function getInfoFirmwareCorrupted(){
	return trim(file_get_contents("/var/lib/updater/status"))==="CORRUPTED";
}

function getInfoTemperature () {
	$ret = array();
	$temp = file_get_contents("/sys/class/hwmon/hwmon0/device/temp1_input");
	if ( $temp=="" )
		$ret['temp'] = "[not found]";
	else
		$ret['temp'] = intval($temp)/1000;
	
	$temp = file_get_contents("/sys/class/hwmon/hwmon0/device/temp1_max_alarm");
	if ( trim( $temp) =="1")
		$ret['max']= true;
	else
		$ret['max']= false;
	$temp = file_get_contents("/sys/class/hwmon/hwmon0/device/temp1_crit_alarm");
	if ( trim( $temp) =="1")
		$ret['crit']= true;
	else
		$ret['crit']= false;
	
	return $ret;
}